package
{
	import flash.ui.Mouse;
	import flash.utils.Dictionary;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{
		[Embed(source = "data/woman.png")] public static var ImgWoman:Class;
		[Embed(source = "data/parrot.png")] public static var ImgParrot:Class;
		[Embed(source = "data/music1.mp3")] public static var SndMusic1:Class;
		[Embed(source = "data/music2.mp3")] public static var SndMusic2:Class;
		[Embed(source = "data/tweet.mp3")] public static var SndTweet:Class;
		[Embed(source = "data/title.mp3")] public static var SndTitle:Class;
		[Embed(source = "data/end.mp3")] public static var SndEnd:Class;
		public var letters:Array = ["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"];
		
	
		
		public var leftStringLbl:FlxText;
		public var rightStringLbl:FlxText;
		
		public var mode:String;
		public var time:Number;
		public var word:String;
		public var myWord:String;
		
		public function genString():void
		{
			var l:int = 3 + FlxG.level;
			word="";
			for (var i:int=0;i<l;i++)
			{
				word+=letters[int(Math.random()*26)];
			}
				
		}
		
		public var left:FlxSprite;
		public var right:FlxSprite;
		override public function create():void
		{
			left = new FlxSprite(0,0);
			left.loadGraphic(GameState.ImgParrot,true,false,49,120);
			left.addAnimation("talk",[1,0],10,false);
			left.addAnimation("idle",[0],0.1,false);
			left.play("idle");
			this.add(left);
			
			right = new FlxSprite(160-49,0);
			right.loadGraphic(GameState.ImgWoman,true,false,49,120);
			right.addAnimation("talk",[1,0],3,true);
			right.addAnimation("idle",[0],10,false);
			right.play("idle");
			this.add(right);
			
			
			Mouse.show();
			time=0;
			genString();
			time=2;
			
			leftStringLbl = new FlxText(60,30,100,"");
			leftStringLbl.visible=false;;
			leftStringLbl.text="";
			this.add(leftStringLbl);
			
			rightStringLbl = new FlxText(0,30,100,"");
			rightStringLbl.visible=false;;
			rightStringLbl.text="";
			this.add(rightStringLbl);
			
			goRight();
		}
		
		public function goLeft():void
		{
			
			FlxG.playMusic(GameState.SndMusic2);
			mode="left";
			myWord="";
			right.visible=false;
			left.visible=true;
			leftStringLbl.visible=true;
			leftStringLbl.text="_";
			rightStringLbl.visible=false;
			time=2;

		}
		
		public function goRight():void
		{
			FlxG.playMusic(GameState.SndMusic1);
			mode="right";
			left.visible=false;
			right.visible=false;
			right.visible=true;
			right.play("talk");
			genString();
			rightStringLbl.visible=true;
			rightStringLbl.text=word;
			leftStringLbl.visible=false;
			time=2;
		}
		
		override public function update():void
		{
		   	time-=FlxG.elapsed;
			if (time<0)
			{
				if (mode=="left")
				{
					FlxG.state = new EndState();								
				}
				else
				{
					goLeft();
				}
			}
			
			if (mode=="left")
			{
				for (var i:int=0;i<26;i++)
				{
					if (FlxG.keys.justPressed(letters[i].toUpperCase()))
					{						
						myWord += letters[i];
						if (myWord.length==word.length)
						{
							left.play("talk",true);
							FlxG.play(GameState.SndTweet);
							if (myWord==word)
							{
								FlxG.level++;
								goRight();
							}
							else
							{
								FlxG.state = new EndState();								
							}
						}
						else
						{
							this.leftStringLbl.text = myWord + "_";
						}
					}
				}
			}
		 	super.update();
		}
	}
}